#include <windows.h>

#define MYWNDCLASS	"Engine3D_Class"
#define MYWNDTITLE	"Engine3D"
#define WIDTH		200 	// ʂ̉̃TCY
#define HEIGHT		150 	// ʂ̏c̃TCY
#define COLOR_BIT	24		// ƗpDIB̐F[x
#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2) // S{oCgE߂

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	VEC3	v[8];		// _W
	int 	f[6][4];	// eʂ̒_ԍ
}MODEL,*LPMODEL;

MODEL	gmCube;
HBITMAP ghBmpWork = NULL;
BYTE	*gpBitsWork = NULL;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Create_Work_Dib();
void Create_Cube();
POINT Perspect(float d_perspect, VEC3 pos, float look_z, POINT move);
void M_Create();
void M_Paint(HDC hDC);
void M_Close();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		M_Create();
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC,hDCcp;
			HBITMAP 	hBmpPre;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			Create_Work_Dib();
			if(ghBmpWork){
				hDCcp = CreateCompatibleDC(hDC);
				hBmpPre = (HBITMAP) SelectObject(hDCcp, ghBmpWork);
				HRGN hrgn = CreateRectRgn(0, 0, WIDTH, HEIGHT);
				SelectClipRgn(hDCcp, hrgn);
				DeleteObject(hrgn);
				M_Paint(hDCcp);
				BitBlt(hDC, 0, 0, WIDTH, HEIGHT, hDCcp, 0, 0, SRCCOPY);
				SelectObject(hDCcp, hBmpPre);
				SelectClipRgn(hDCcp, (HRGN) NULL);
				DeleteDC(hDCcp);
				DeleteObject(ghBmpWork);
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		M_Close();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// ƗpDIB̍쐬
void Create_Work_Dib()
{
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= WIDTH;
	bmi.bmiHeader.biHeight			= -HEIGHT;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= COLOR_BIT;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	ghBmpWork = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (VOID **)&gpBitsWork, NULL, 0);
	
	int workSize = WIDTHBYTES(WIDTH * COLOR_BIT) * HEIGHT;
	ZeroMemory(gpBitsWork, workSize);
}// Create_Work_Dib

// ̂̍쐬
void Create_Cube()
{
	VEC3	v[8]	=	{{0.5f,0.5f,-0.5f},{0.5f,0.5f,0.5f},{-0.5f,0.5f,0.5f},
						{-0.5f,0.5f,-0.5f},{0.5f,-0.5f,-0.5f},{0.5f,-0.5f,0.5f},
						{-0.5f,-0.5f,0.5f},{-0.5f,-0.5f,-0.5f}};
	int 	f[6][4] =	{{3,2,1,0},{0,1,5,4},{1,2,6,5},{2,3,7,6},{3,0,4,7},{4,5,6,7}};
	memcpy(gmCube.v, v, sizeof(gmCube.v));
	memcpy(gmCube.f, f, sizeof(gmCube.f));
}// Create_Cube

// 
POINT Perspect(float d_perspect, VEC3 pos, float look_z, POINT move)
{
	POINT pt;
	if(pos.z == look_z){
		pt.x = move.x;
		pt.y = move.y;
	}
	else{
		pt.x = (long)( pos.x * d_perspect / (pos.z - look_z)) + move.x;
		pt.y = (long)(-pos.y * d_perspect / (pos.z - look_z)) + move.y;
	}
	return pt;
}// Perspect

// 
void M_Create()
{
	Create_Cube();
}// M_Create

// `
// `
void M_Paint(HDC hDC)
{
	int 		i,j,index;
	POINT		pt[4];
	const float d_perspect = HEIGHT;				// ۂł̓eXN[Ǝ_̋
	const float look_z = 2.0f;						// _ZW
	const POINT offset = {WIDTH / 2, HEIGHT / 2};	// ی̓񎟌W̕sړ
	const HPEN  hpen = (HPEN) GetStockObject(WHITE_PEN);
	
	HPEN hpenPre = (HPEN) SelectObject(hDC, hpen);
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			index = gmCube.f[i][j];
			pt[j] = Perspect(d_perspect, gmCube.v[index], look_z, offset);

		}
		Polyline(hDC, pt, 4);
	}
	SelectObject(hDC, hpenPre);
}// M_Paint


// I
void M_Close()
{
}// M_Close