#include <windows.h>
#include <math.h>

#define MYWNDCLASS	"Engine3D_Class"
#define MYWNDTITLE	"Engine3D"
#define WIDTH		200 	// ʂ̉̃TCY
#define HEIGHT		150 	// ʂ̏c̃TCY
#define COLOR_BIT	24		// ƗpDIB̐F[x
#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2)	// S{oCgE߂

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	union{
		struct{
			float	_11, _12, _13, _14;
			float	_21, _22, _23, _24;
			float	_31, _32, _33, _34;
			float	_41, _42, _43, _44;
		};
		float m[4][4];
	};
}MTRX,*LPMTRX;

typedef struct{
	VEC3	v[8];		// _̍W
	int		f[6][4];	// eʂ̒_ԍ
}MODEL,*LPMODEL;

HBITMAP ghBmpWork = NULL;
BYTE	*gpBitsWork = NULL;
MODEL	gmCube;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Create_Work_Dib();
void Create_Cube();
VEC3 Vec3Sub(VEC3 v1, VEC3 v2);
VEC3 Vec3Normalize(VEC3 vin);
VEC3 Vec3Cross(VEC3 v1, VEC3 v2);
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup);
VEC3 MtrxVec3(VEC3 v, MTRX mt);
POINT Perspect(float d_perspect, VEC3 pos, float look_z, POINT move);
void M_Create();
void M_Paint(HDC hDC);
void M_Close();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		M_Create();
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC,hDCcp;
			HBITMAP		hBmpPre;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			Create_Work_Dib();
			if(ghBmpWork){
				hDCcp = CreateCompatibleDC(hDC);
				hBmpPre = (HBITMAP) SelectObject(hDCcp, ghBmpWork);
				HRGN hrgn = CreateRectRgn(0, 0, WIDTH, HEIGHT);
				SelectClipRgn(hDCcp, hrgn);
				DeleteObject(hrgn);
				M_Paint(hDCcp);
				BitBlt(hDC, 0, 0, WIDTH, HEIGHT, hDCcp, 0, 0, SRCCOPY);
				SelectObject(hDCcp, hBmpPre);
				SelectClipRgn(hDCcp, (HRGN) NULL);
				DeleteDC(hDCcp);
				DeleteObject(ghBmpWork);
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		M_Close();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// ƗpDIB̍쐬
void Create_Work_Dib()
{
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= WIDTH;
	bmi.bmiHeader.biHeight			= -HEIGHT;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= COLOR_BIT;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	ghBmpWork = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (VOID **)&gpBitsWork, NULL, 0);
	
	int workSize = WIDTHBYTES(WIDTH * COLOR_BIT) * HEIGHT;
	ZeroMemory(gpBitsWork, workSize);
}// Create_Work_Dib

// ̂̍쐬
void Create_Cube()
{
	VEC3	v[8]	=	{{0.5f,0.5f,-0.5f},{0.5f,0.5f,0.5f},{-0.5f,0.5f,0.5f},
						{-0.5f,0.5f,-0.5f},{0.5f,-0.5f,-0.5f},{0.5f,-0.5f,0.5f},
						{-0.5f,-0.5f,0.5f},{-0.5f,-0.5f,-0.5f}};
	int		f[6][4]	=	{{3,2,1,0},{0,1,5,4},{1,2,6,5},{2,3,7,6},{3,0,4,7},{4,5,6,7}};
	memcpy(gmCube.v, v, sizeof(gmCube.v));
	memcpy(gmCube.f, f, sizeof(gmCube.f));
}// Create_Cube

// xNg̈Z
VEC3 Vec3Sub(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.x  - v2.x;
	vout.y = v1.y  - v2.y;
	vout.z = v1.z  - v2.z;
	return vout;
}// Vec3Sub

// PʃxNg
VEC3 Vec3Normalize(VEC3 vin)
{
	VEC3	vout;
	float	len = (float) sqrt(vin.x * vin.x + vin.y * vin.y + vin.z * vin.z);
	if(len == 0.0f){
		vout.x = 0.0f;
		vout.y = 0.0f;
		vout.z = 0.0f;
	}
	else{
		vout.x = vin.x / len;
		vout.y = vin.y / len;
		vout.z = vin.z / len;
	}
	return vout;
}// Vec3Normalize

// O
VEC3 Vec3Cross(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.y * v2.z - v1.z * v2.y;
	vout.y = v1.z * v2.x - v1.x * v2.z;
	vout.z = v1.x * v2.y - v1.y * v2.x;
	return vout;
}// Vec3Cross

// r[s
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup)
{
	MTRX mt;
	VEC3 v_x,v_y,v_z;
	v_z = Vec3Normalize(Vec3Sub(v_lookat, v_look));
	v_x = Vec3Normalize(Vec3Cross(v_lookup, v_z));
	v_y = Vec3Cross(v_z, v_x);
	mt._11 = v_x.x;
	mt._12 = v_y.x;
	mt._13 = v_z.x;
	mt._14 = 0;
	mt._21 = v_x.y;
	mt._22 = v_y.y;
	mt._23 = v_z.y;
	mt._24 = 0;
	mt._31 = v_x.z;
	mt._32 = v_y.z;
	mt._33 = v_z.z;
	mt._34 = 0;
	mt._41 = 0;
	mt._42 = 0;
	mt._43 = 0;
	mt._44 = 1;
	return mt;
}// MtrxView

// sWɓKp
VEC3 MtrxVec3(VEC3 v, MTRX mt)
{
	VEC3 v2;
	v2.x = v.x * mt._11 + v.y * mt._21 + v.z * mt._31 + mt._41;
	v2.y = v.x * mt._12 + v.y * mt._22 + v.z * mt._32 + mt._42;
	v2.z = v.x * mt._13 + v.y * mt._23 + v.z * mt._33 + mt._43;
	return v2;
}// MtrxVec3

// 
POINT Perspect(float d_perspect, VEC3 pos, float look_z, POINT move)
{
	POINT pt;
	if(pos.z == look_z){
		pt.x = move.x;
		pt.y = move.y;
	}
	else{
		pt.x = (long)( pos.x * d_perspect / (pos.z - look_z)) + move.x;
		pt.y = (long)(-pos.y * d_perspect / (pos.z - look_z)) + move.y;
	}
	return pt;
}// Perspect

// 
void M_Create()
{
	Create_Cube();
}// M_Create

// `
void M_Paint(HDC hDC)
{
	int			i,j;
	POINT		pt[4];
	const float	d_perspect = HEIGHT;				// ۂł̓eXN[Ǝ_̋
	const POINT	offset = {WIDTH / 2, HEIGHT / 2};	// ی̓񎟌W̕sړ
	const VEC3	pos_look = {1.0f, 0.0f, -2.0f};		// _̈ʒu
	const VEC3	pos_lookat = {0, 0, 0};				// _̈ʒu
	const VEC3	v_lookup = {0, 1, 0};				// _̏
	const HPEN  hpen = (HPEN) GetStockObject(WHITE_PEN);
	
	MTRX mt_view = MtrxView(pos_look, pos_lookat, v_lookup);
	
	HPEN hpenPre = (HPEN) SelectObject(hDC, hpen);
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			int  index = gmCube.f[i][j];
			VEC3 v = MtrxVec3(gmCube.v[index], mt_view);
			pt[j] = Perspect(d_perspect, v, pos_look.z, offset);
		}
		Polyline(hDC, pt, 4);
	}
	SelectObject(hDC, hpenPre);
}// M_Paint

// I
void M_Close()
{
}// M_Close