#include <windows.h>
#include <math.h>

#define MYWNDCLASS	"Engine3D_Class"
#define MYWNDTITLE	"Engine3D"
#define WIDTH		200 	// ʂ̉̃TCY
#define HEIGHT		150 	// ʂ̏c̃TCY
#define COLOR_BIT	24		// ƗpDIB̐F[x
#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2)	// S{oCgE߂

typedef struct{
	BYTE	r;
	BYTE	g;
	BYTE	b;
}COLOR,*LPCOLOR;

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	union{
		struct{
			float	_11, _12, _13, _14;
			float	_21, _22, _23, _24;
			float	_31, _32, _33, _34;
			float	_41, _42, _43, _44;
		};
		float m[4][4];
	};
}MTRX,*LPMTRX;

typedef struct{
	VEC3	v[8];		// _̍W
	int		f[6][4];	// eʂ̒_ԍ
	VEC3	fn[6];		// ʖ@xNg
}MODEL,*LPMODEL;

HBITMAP ghBmpWork = NULL;
BYTE	*gpBitsWork = NULL;
MODEL	gmCube;			// ̏

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Create_Work_Dib();
void Create_Cube();
VEC3 Vec3Sub(VEC3 v1, VEC3 v2);
VEC3 Vec3Normalize(VEC3 vin);
float Vec3Dot(VEC3 v1, VEC3 v2);
VEC3 Vec3Cross(VEC3 v1, VEC3 v2);
MTRX MtrxIdent();
MTRX MtrxRotY(float radian);
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup);
MTRX MtrxMult(MTRX mt1, MTRX mt2);
VEC3 MtrxVec3(VEC3 v, MTRX mt);
VEC3 Perspect(VEC3 pos, float look_z);
VEC3 Get_FaceNormal(VEC3 *v);
void M_Create();
void M_Paint(HDC hDC);
void M_Close();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		M_Create();
		SetTimer(hWnd, 1, 100, NULL);
		return 0;
	case WM_TIMER:
		InvalidateRect(hWnd, NULL, FALSE);	// ĕ`
		break;
	case WM_PAINT:
		{
			HDC 		hDC,hDCcp;
			HBITMAP		hBmpPre;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			Create_Work_Dib();
			if(ghBmpWork){
				hDCcp = CreateCompatibleDC(hDC);
				hBmpPre = (HBITMAP) SelectObject(hDCcp, ghBmpWork);
				HRGN hrgn = CreateRectRgn(0, 0, WIDTH, HEIGHT);
				SelectClipRgn(hDCcp, hrgn);
				DeleteObject(hrgn);
				M_Paint(hDCcp);
				BitBlt(hDC, 0, 0, WIDTH, HEIGHT, hDCcp, 0, 0, SRCCOPY);
				SelectObject(hDCcp, hBmpPre);
				SelectClipRgn(hDCcp, (HRGN) NULL);
				DeleteDC(hDCcp);
				DeleteObject(ghBmpWork);
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		KillTimer(hWnd, 1);
		M_Close();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// ƗpDIB̍쐬
void Create_Work_Dib()
{
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= WIDTH;
	bmi.bmiHeader.biHeight			= -HEIGHT;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= COLOR_BIT;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	ghBmpWork = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (VOID **)&gpBitsWork, NULL, 0);
	
	int workSize = WIDTHBYTES(WIDTH * COLOR_BIT) * HEIGHT;
	ZeroMemory(gpBitsWork, workSize);
}// Create_Work_Dib

// ̂̍쐬
void Create_Cube()
{
	VEC3	v[8]	=	{{0.5f,0.5f,-0.5f},{0.5f,0.5f,0.5f},{-0.5f,0.5f,0.5f},
						{-0.5f,0.5f,-0.5f},{0.5f,-0.5f,-0.5f},{0.5f,-0.5f,0.5f},
						{-0.5f,-0.5f,0.5f},{-0.5f,-0.5f,-0.5f}};
	int		f[6][4]	=	{{3,2,1,0},{0,1,5,4},{1,2,6,5},{2,3,7,6},{3,0,4,7},{4,5,6,7}};
	memcpy(gmCube.v, v, sizeof(gmCube.v));
	memcpy(gmCube.f, f, sizeof(gmCube.f));
}// Create_Cube

// xNg̈Z
VEC3 Vec3Sub(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.x  - v2.x;
	vout.y = v1.y  - v2.y;
	vout.z = v1.z  - v2.z;
	return vout;
}// Vec3Sub

// PʃxNg
VEC3 Vec3Normalize(VEC3 vin)
{
	VEC3	vout;
	float	len = (float) sqrt(vin.x * vin.x + vin.y * vin.y + vin.z * vin.z);
	if(len == 0.0f){
		vout.x = 0.0f;
		vout.y = 0.0f;
		vout.z = 0.0f;
	}
	else{
		vout.x = vin.x / len;
		vout.y = vin.y / len;
		vout.z = vin.z / len;
	}
	return vout;
}// Vec3Normalize

// 
float Vec3Dot(VEC3 v1, VEC3 v2)
{
	return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z);
}

// O
VEC3 Vec3Cross(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.y * v2.z - v1.z * v2.y;
	vout.y = v1.z * v2.x - v1.x * v2.z;
	vout.z = v1.x * v2.y - v1.y * v2.x;
	return vout;
}// Vec3Cross

// Pʍs
MTRX MtrxIdent()
{
	MTRX mt = { 1,0,0,0,
				0,1,0,0,
				0,0,1,0,
				0,0,0,1};
	return mt;
}// MtrxIdent

// sY]
MTRX MtrxRotY(float radian)
{
	MTRX mt = MtrxIdent();
	mt._11 = (float)  cos(radian);
	mt._13 = (float) -sin(radian);
	mt._31 = (float)  sin(radian);
	mt._33 = (float)  cos(radian);
	return mt;
}// MtrxRotY

// r[s
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup)
{
	MTRX mt;
	VEC3 v_x,v_y,v_z;
	v_z = Vec3Normalize(Vec3Sub(v_lookat, v_look));
	v_x = Vec3Normalize(Vec3Cross(v_lookup, v_z));
	v_y = Vec3Cross(v_z, v_x);
	mt._11 = v_x.x;
	mt._12 = v_y.x;
	mt._13 = v_z.x;
	mt._14 = 0;
	mt._21 = v_x.y;
	mt._22 = v_y.y;
	mt._23 = v_z.y;
	mt._24 = 0;
	mt._31 = v_x.z;
	mt._32 = v_y.z;
	mt._33 = v_z.z;
	mt._34 = 0;
	mt._41 = 0;
	mt._42 = 0;
	mt._43 = 0;
	mt._44 = 1;
	return mt;
}// MtrxView

// sA
MTRX MtrxMult(MTRX mt1, MTRX mt2)
{
	MTRX mt;
	mt._11 = mt1._11 * mt2._11 + mt1._12 * mt2._21 + mt1._13 * mt2._31 + mt1._14 * mt2._41;
	mt._12 = mt1._11 * mt2._12 + mt1._12 * mt2._22 + mt1._13 * mt2._32 + mt1._14 * mt2._42;
	mt._13 = mt1._11 * mt2._13 + mt1._12 * mt2._23 + mt1._13 * mt2._33 + mt1._14 * mt2._43;
	mt._14 = mt1._11 * mt2._14 + mt1._12 * mt2._24 + mt1._13 * mt2._34 + mt1._14 * mt2._44;
	mt._21 = mt1._21 * mt2._11 + mt1._22 * mt2._21 + mt1._23 * mt2._31 + mt1._24 * mt2._41;
	mt._22 = mt1._21 * mt2._12 + mt1._22 * mt2._22 + mt1._23 * mt2._32 + mt1._24 * mt2._42;
	mt._23 = mt1._21 * mt2._13 + mt1._22 * mt2._23 + mt1._23 * mt2._33 + mt1._24 * mt2._43;
	mt._24 = mt1._21 * mt2._14 + mt1._22 * mt2._24 + mt1._23 * mt2._34 + mt1._24 * mt2._44;
	mt._31 = mt1._31 * mt2._11 + mt1._32 * mt2._21 + mt1._33 * mt2._31 + mt1._34 * mt2._41;
	mt._32 = mt1._31 * mt2._12 + mt1._32 * mt2._22 + mt1._33 * mt2._32 + mt1._34 * mt2._42;
	mt._33 = mt1._31 * mt2._13 + mt1._32 * mt2._23 + mt1._33 * mt2._33 + mt1._34 * mt2._43;
	mt._34 = mt1._31 * mt2._14 + mt1._32 * mt2._24 + mt1._33 * mt2._34 + mt1._34 * mt2._44;
	mt._41 = mt1._41 * mt2._11 + mt1._42 * mt2._21 + mt1._43 * mt2._31 + mt1._44 * mt2._41;
	mt._42 = mt1._41 * mt2._12 + mt1._42 * mt2._22 + mt1._43 * mt2._32 + mt1._44 * mt2._42;
	mt._43 = mt1._41 * mt2._13 + mt1._42 * mt2._23 + mt1._43 * mt2._33 + mt1._44 * mt2._43;
	mt._44 = mt1._41 * mt2._14 + mt1._42 * mt2._24 + mt1._43 * mt2._34 + mt1._44 * mt2._44;
	return mt;
}// MtrxMult

// sWɓKp
VEC3 MtrxVec3(VEC3 v, MTRX mt)
{
	VEC3 v2;
	v2.x = v.x * mt._11 + v.y * mt._21 + v.z * mt._31 + mt._41;
	v2.y = v.x * mt._12 + v.y * mt._22 + v.z * mt._32 + mt._42;
	v2.z = v.x * mt._13 + v.y * mt._23 + v.z * mt._33 + mt._43;
	return v2;
}// MtrxVec3

// 
VEC3 Perspect(VEC3 pos, float look_z)
{
	VEC3 pos_dst;
	if(pos.z == look_z){
		pos_dst.x = 0;
		pos_dst.y = 0;
	}
	else{
		pos_dst.x = pos.x / (pos.z - look_z);
		pos_dst.y = pos.y / (pos.z - look_z);
	}
	pos_dst.z = pos.z;
	return pos_dst;
}// Perspect

// ʖ@̎擾
VEC3 Get_FaceNormal(VEC3 *v)
{
	VEC3	v1,v2;
	
	v1 = Vec3Sub(v[1], v[0]);
	v2 = Vec3Sub(v[2], v[1]);
	 return Vec3Normalize(Vec3Cross(v1, v2));
}// Get_FaceNormal

// 
void M_Create()
{
	// ̍쐬
	Create_Cube();
	// ʖ@xNgZo
	int		i,j;
	VEC3	v[4];
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			v[j] = gmCube.v[gmCube.f[i][j]];
		}
		gmCube.fn[i] = Get_FaceNormal(v);
	}
}// M_Create

// `
void M_Paint(HDC hDC)
{
	int			i,j;
	VEC3		v_prj[4];
	POINT		pt[4];
	const float	d_perspect = HEIGHT;				// ۂł̓eXN[Ǝ_̋
	const POINT	offset = {WIDTH / 2, HEIGHT / 2};	// ی̓񎟌W̕sړ
	const VEC3	pos_look = {0.0f, 2.0f, -2.0f};		// _̈ʒu
	const VEC3	pos_lookat = {0, 0, 0};				// _̈ʒu
	const VEC3	v_lookup = {0, 1, 0};				// _̏
	VEC3		v_sun = {0.0f, -1.0f, 1.0f};		// ˌ̃xNg
	VEC3		v_look;								// _王_ւ̃xNg
	HBRUSH		hbr,hbrPre;
	const float	power1		= 0.7f;					// ˂̋i0 ` 1j
	const COLOR	material	= {255, 255, 255};		// ʂ̃fBt[YFieF 0 ` 255j
	const COLOR	ambient		= {10, 10, 10};			// ieF 0 ` 255j
	float		power2;
	UINT		r,g,b;
	COLOR		rgb;
	MTRX		mt_view,mt_world,mt_worldview;
	static int	roll_y = 0;							// ]px
	
	// sݒ
	mt_world		= MtrxRotY(roll_y * 3.14f / 180);
	mt_view			= MtrxView(pos_look, pos_lookat, v_lookup);
	mt_worldview	= MtrxMult(mt_world, mt_view);
	// ˌxNg
	v_sun.x = - v_sun.x;
	v_sun.y = - v_sun.y;
	v_sun.z = - v_sun.z;
	v_sun	= Vec3Normalize(v_sun);
	// xNg
	v_look	= Vec3Normalize(MtrxVec3(Vec3Sub(pos_lookat, pos_look), mt_view));
	
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			int  index = gmCube.f[i][j];
			// _̃[hEr[sϊ
			VEC3 v = MtrxVec3(gmCube.v[index], mt_worldview);
			// _̓
			v_prj[j] = Perspect(v, pos_look.z);
			// _̊gƕsړ
			pt[j].x = (long)( v_prj[j].x * d_perspect + offset.x);
			pt[j].y = (long)(-v_prj[j].y * d_perspect + offset.y);
		}
		// ʖ@xNgvZiJOpj
		VEC3	fn_cull = Get_FaceNormal(v_prj);
		// ʖ@xNg̃[hsϊiFpj
		VEC3	fn_color = Vec3Normalize(MtrxVec3(gmCube.fn[i], mt_world));
		// JO
		float	dot_cull = Vec3Dot(v_look, fn_cull);
		if(dot_cull < 0){	// Жʕ\
			// Lambert ƖfɂgUːFݒ
			power2 = power1 * Vec3Dot(v_sun, fn_color);
			if(power2 < 0){
				power2 = 0;
			}
			r = (UINT)(material.r * power2 + ambient.r);
			g = (UINT)(material.g * power2 + ambient.g);
			b = (UINT)(material.b * power2 + ambient.b);
			if(r > 255)	r = 255;
			if(g > 255)	g = 255;
			if(b > 255)	b = 255;
			rgb.r = (BYTE) r;
			rgb.g = (BYTE) g;
			rgb.b = (BYTE) b;
			hbr = (HBRUSH) CreateSolidBrush(RGB(rgb.r, rgb.g, rgb.b));
			hbrPre = (HBRUSH) SelectObject(hDC, hbr);
			Polygon(hDC, pt, 4);
			SelectObject(hDC, hbrPre);
			DeleteObject(hbr);
		}
	}
	// ]px
	roll_y += 10;
	if(roll_y >= 360)
		roll_y = 0;
}// M_Paint

// I
void M_Close()
{
}// M_Close