#include <windows.h>
#include <math.h>

#pragma comment(lib,"msimg32.lib")

#define MYWNDCLASS	"Engine3D_Class"
#define MYWNDTITLE	"Engine3D"
#define WIDTH		200 	// ʂ̉̃TCY
#define HEIGHT		150 	// ʂ̏c̃TCY
#define COLOR_BIT	24		// ƗpDIB̐F[x
#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2)	// S{oCgE߂

typedef struct{
	BYTE	r;
	BYTE	g;
	BYTE	b;
}RGBB,*LPRGBB;

typedef struct{
	int	a;
	int	r;
	int	g;
	int	b;
}ARGBN,*LPARGBN;

typedef struct{
	POINT		pos;	// _W
	ARGBN		c;		// _ƖF
	float		z;		// _Zl
}POLYPAINT,*LPPOLYPAINT;

typedef struct{
	int			y_min;	// ӂ̍ŏYW
	int			y_max;	// ӂ̍őYW
	int			x_min;	// ӂ̍ŏYWXW
	int			x;		// XLCƕӂ̌_XW
	double		slant;	// ӂ̌X̋t̐
	double		slant_sum;	// slant̘a
	ARGBN		c_min;	// ӂ̍ŏYW̏ƖF
	ARGBN		c_max;	// ӂ̍őYW̏ƖF
	ARGBN		color;	// ƖF
	float		z_min;	// ӂ̍ŏYWZl
	float		z_max;	// ӂ̍őYWZl
	float		z;		// Zl
	int			next;	// ̃f[^ԍ
}EDGE,*LPEDGE;

typedef struct{
	int		index;		// ŏ̃f[^ԍ
	int		last;		// Ō̃f[^ԍ
}ET,*LPET;

typedef struct{
	float	f1;
	float	f2;
}RATE,*LPRATE;

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	union{
		struct{
			float	_11, _12, _13, _14;
			float	_21, _22, _23, _24;
			float	_31, _32, _33, _34;
			float	_41, _42, _43, _44;
		};
		float m[4][4];
	};
}MTRX,*LPMTRX;

typedef struct{
	VEC3	v[8];		// _W
	VEC3	n[8];		// _@xNg
	int		f[6][4];	// eʂ̒_ԍ
	VEC3	fn[6];		// ʖ@xNg
}MODEL,*LPMODEL;

HBITMAP	ghBmpWork = NULL;
BYTE	*gpBitsWork = NULL;
MODEL	gmCube;						// ̏
float	gZBuf[HEIGHT][WIDTH];		// Zobt@
bool	gStencilBuf[HEIGHT][WIDTH];	// XeV obt@
bool	gFlagStencilWrite = false;	// XeV obt@LtOiݗpj
bool	gFlagStencilJudge = false;	// XeV obt@LtOipj
float	gZFar = 1;					// ĉZl
MTRX	gMtProj,gMtView,gMtWorld,gMtWorldView,gMtAll;
VEC3	gPosLook,gPosLookAt;
bool	gFlagPerspect = false;		// false:sہAtrue:ˉe

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Create_Work_Dib();
void Create_Cube();
VEC3 Vec3Sub(VEC3 v1, VEC3 v2);
VEC3 Vec3Normalize(VEC3 vin);
float Vec3Dot(VEC3 v1, VEC3 v2);
VEC3 Vec3Cross(VEC3 v1, VEC3 v2);
MTRX MtrxIdent();
MTRX MtrxRotY(float radian);
MTRX MtrxTranslate(float x, float y, float z);
MTRX MtrxScal(float x, float y, float z);
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup);
MTRX MtrxPerspect(float zn, float zf, float fov_y, float aspect);
MTRX MtrxOrtho(float zn, float zf, float w, float h);
MTRX MtrxMult(MTRX mt1, MTRX mt2);
VEC3 MtrxVec3(VEC3 v, MTRX mt);
VEC3 Get_FaceNormal(VEC3 *v);
void Set_Normal();
void Clear_Z_StencilBuf();
void Draw_Cube(HDC hDC, VEC3 v_sun);
void Paint_Triangle(HDC hDC, LPPOLYPAINT pp);
void Set_Data1(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et);
void Set_Data2(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et);
void Set_ValRate(LPRATE rate, int idx, int idx_min, int idx_max);
void Set_Color(LPARGBN color, LPRATE rate, ARGBN c_min, ARGBN c_max);
void Set_Z(float *z, LPRATE rate, float z_min, float z_max);
int Round(double val);
void M_Create();
void M_Paint(HDC hDC);
void M_Close();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		M_Create();
		SetTimer(hWnd, 1, 100, NULL);
		return 0;
	case WM_TIMER:
		InvalidateRect(hWnd, NULL, FALSE);	// ĕ`
		break;
	case WM_PAINT:
		{
			HDC 		hDC,hDCcp;
			HBITMAP		hBmpPre;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			Create_Work_Dib();
			if(ghBmpWork){
				hDCcp = CreateCompatibleDC(hDC);
				hBmpPre = (HBITMAP) SelectObject(hDCcp, ghBmpWork);
				HRGN hrgn = CreateRectRgn(0, 0, WIDTH, HEIGHT);
				SelectClipRgn(hDCcp, hrgn);
				DeleteObject(hrgn);
				M_Paint(hDCcp);
				BitBlt(hDC, 0, 0, WIDTH, HEIGHT, hDCcp, 0, 0, SRCCOPY);
				SelectObject(hDCcp, hBmpPre);
				SelectClipRgn(hDCcp, (HRGN) NULL);
				DeleteDC(hDCcp);
				DeleteObject(ghBmpWork);
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		KillTimer(hWnd, 1);
		M_Close();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// ƗpDIB̍쐬
void Create_Work_Dib()
{
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= WIDTH;
	bmi.bmiHeader.biHeight			= -HEIGHT;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= COLOR_BIT;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	ghBmpWork = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (VOID **)&gpBitsWork, NULL, 0);
	
	int workSize = WIDTHBYTES(WIDTH * COLOR_BIT) * HEIGHT;
	ZeroMemory(gpBitsWork, workSize);
}// Create_Work_Dib

// ̂̍쐬
void Create_Cube()
{
	VEC3	v[8]	=	{{0.5f,0.5f,-0.5f},{0.5f,0.5f,0.5f},{-0.5f,0.5f,0.5f},
						{-0.5f,0.5f,-0.5f},{0.5f,-0.5f,-0.5f},{0.5f,-0.5f,0.5f},
						{-0.5f,-0.5f,0.5f},{-0.5f,-0.5f,-0.5f}};
	int		f[6][4]	=	{{3,2,1,0},{0,1,5,4},{1,2,6,5},{2,3,7,6},{3,0,4,7},{4,5,6,7}};
	memcpy(gmCube.v, v, sizeof(gmCube.v));
	memcpy(gmCube.f, f, sizeof(gmCube.f));
}// Create_Cube

// xNg̈Z
VEC3 Vec3Sub(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.x  - v2.x;
	vout.y = v1.y  - v2.y;
	vout.z = v1.z  - v2.z;
	return vout;
}// Vec3Sub

// PʃxNg
VEC3 Vec3Normalize(VEC3 vin)
{
	VEC3	vout;
	float	len = (float) sqrt(vin.x * vin.x + vin.y * vin.y + vin.z * vin.z);
	if(len == 0.0f){
		vout.x = 0.0f;
		vout.y = 0.0f;
		vout.z = 0.0f;
	}
	else{
		vout.x = vin.x / len;
		vout.y = vin.y / len;
		vout.z = vin.z / len;
	}
	return vout;
}// Vec3Normalize

// 
float Vec3Dot(VEC3 v1, VEC3 v2)
{
	return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z);
}

// O
VEC3 Vec3Cross(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.y * v2.z - v1.z * v2.y;
	vout.y = v1.z * v2.x - v1.x * v2.z;
	vout.z = v1.x * v2.y - v1.y * v2.x;
	return vout;
}// Vec3Cross

// Pʍs
MTRX MtrxIdent()
{
	MTRX mt = { 1,0,0,0,
				0,1,0,0,
				0,0,1,0,
				0,0,0,1};
	return mt;
}// MtrxIdent

// sY]
MTRX MtrxRotY(float radian)
{
	MTRX mt = MtrxIdent();
	mt._11 = (float)  cos(radian);
	mt._13 = (float) -sin(radian);
	mt._31 = (float)  sin(radian);
	mt._33 = (float)  cos(radian);
	return mt;
}// MtrxRotY

// s̈ړ
MTRX MtrxTranslate(float x, float y, float z)
{
	MTRX mt = MtrxIdent();
	mt._41 = x;
	mt._42 = y;
	mt._43 = z;
	return mt;
}// MtrxTranslate

// s̃XP[O
MTRX MtrxScal(float x, float y, float z)
{
	MTRX mt = MtrxIdent();
	mt._11 = x;
	mt._22 = y;
	mt._33 = z;
	return mt;
}// MtrxScal

// r[s
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup)
{
	MTRX mt;
	VEC3 v_x,v_y,v_z;
	gPosLook	= v_look;
	gPosLookAt	= v_lookat;
	v_z = Vec3Normalize(Vec3Sub(v_lookat, v_look));
	v_x = Vec3Normalize(Vec3Cross(v_lookup, v_z));
	v_y = Vec3Cross(v_z, v_x);
	mt._11 = v_x.x;
	mt._12 = v_y.x;
	mt._13 = v_z.x;
	mt._14 = 0;
	mt._21 = v_x.y;
	mt._22 = v_y.y;
	mt._23 = v_z.y;
	mt._24 = 0;
	mt._31 = v_x.z;
	mt._32 = v_y.z;
	mt._33 = v_z.z;
	mt._34 = 0;
	mt._41 = - Vec3Dot(v_x, v_look);
	mt._42 = - Vec3Dot(v_y, v_look);
	mt._43 = - Vec3Dot(v_z, v_look);
	mt._44 = 1;
	return mt;
}// MtrxView
/*
// ˉeۍs
MTRX MtrxPerspect(float near_plane, float far_plane, float fov_horiz, float fov_vert)
{
	float	h, w, Q;
	
	gZFar = far_plane;
	
	if(fov_horiz == 0)
		fov_horiz = 1;
	if(fov_vert == 0)
		fov_vert = 1;

	w = 1.0f / (float)tan(fov_horiz * 0.5);  // 1/tan(x) == cot(x)
	h = 1.0f / (float)tan(fov_vert * 0.5);   // 1/tan(x) == cot(x)
	Q = far_plane / (far_plane - near_plane);
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = w;
	mt._22 = h;
	mt._33 = Q;
	mt._43 = -Q * near_plane;
	mt._34 = 1;
	
	return mt;
}// MtrxPerspect
*/

// ˉeۍs
MTRX MtrxPerspect(float zn, float zf, float fov_y, float aspect)
{
	float	c, s, Q;
	
	gFlagPerspect = true;
	
	if(zf == 0){
		zf = 0.001f;
	}
	gZFar = zf;
	
	c = (float) cos(fov_y * 0.5);
	s = (float) sin(aspect * 0.5);
	if(zn != zf){
		Q = s / (1.0f - zn / zf);
	}
	else{
		Q = 1.0f;
	}
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = c;
	mt._22 = c;
	mt._33 = Q;
	mt._43 = -Q * zn;
	mt._34 = s;
	
	return mt;
}// MtrxPerspect

// sۍs
MTRX MtrxOrtho(float zn, float zf, float w, float h)
{
	float	sub;
	
	gFlagPerspect = false;
	
	gZFar = zf;
	
	if(zn != zf)
		sub = zf - zn;
	else
		sub = 1;
	if(w == 0)
		w = 1;
	if(h == 0)
		h = 1;
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = 2.0f / w;
	mt._22 = 2.0f / h;
	mt._33 = 1.0f / sub;
	mt._43 = - zn / sub;
	mt._34 = 1;
	
	return mt;
}// MtrxOrtho

// sA
MTRX MtrxMult(MTRX mt1, MTRX mt2)
{
	MTRX mt;
	mt._11 = mt1._11 * mt2._11 + mt1._12 * mt2._21 + mt1._13 * mt2._31 + mt1._14 * mt2._41;
	mt._12 = mt1._11 * mt2._12 + mt1._12 * mt2._22 + mt1._13 * mt2._32 + mt1._14 * mt2._42;
	mt._13 = mt1._11 * mt2._13 + mt1._12 * mt2._23 + mt1._13 * mt2._33 + mt1._14 * mt2._43;
	mt._14 = mt1._11 * mt2._14 + mt1._12 * mt2._24 + mt1._13 * mt2._34 + mt1._14 * mt2._44;
	mt._21 = mt1._21 * mt2._11 + mt1._22 * mt2._21 + mt1._23 * mt2._31 + mt1._24 * mt2._41;
	mt._22 = mt1._21 * mt2._12 + mt1._22 * mt2._22 + mt1._23 * mt2._32 + mt1._24 * mt2._42;
	mt._23 = mt1._21 * mt2._13 + mt1._22 * mt2._23 + mt1._23 * mt2._33 + mt1._24 * mt2._43;
	mt._24 = mt1._21 * mt2._14 + mt1._22 * mt2._24 + mt1._23 * mt2._34 + mt1._24 * mt2._44;
	mt._31 = mt1._31 * mt2._11 + mt1._32 * mt2._21 + mt1._33 * mt2._31 + mt1._34 * mt2._41;
	mt._32 = mt1._31 * mt2._12 + mt1._32 * mt2._22 + mt1._33 * mt2._32 + mt1._34 * mt2._42;
	mt._33 = mt1._31 * mt2._13 + mt1._32 * mt2._23 + mt1._33 * mt2._33 + mt1._34 * mt2._43;
	mt._34 = mt1._31 * mt2._14 + mt1._32 * mt2._24 + mt1._33 * mt2._34 + mt1._34 * mt2._44;
	mt._41 = mt1._41 * mt2._11 + mt1._42 * mt2._21 + mt1._43 * mt2._31 + mt1._44 * mt2._41;
	mt._42 = mt1._41 * mt2._12 + mt1._42 * mt2._22 + mt1._43 * mt2._32 + mt1._44 * mt2._42;
	mt._43 = mt1._41 * mt2._13 + mt1._42 * mt2._23 + mt1._43 * mt2._33 + mt1._44 * mt2._43;
	mt._44 = mt1._41 * mt2._14 + mt1._42 * mt2._24 + mt1._43 * mt2._34 + mt1._44 * mt2._44;
	return mt;
}// MtrxMult

// sWɓKp
VEC3 MtrxVec3(VEC3 v, MTRX mt)
{
	VEC3 v2;
	v2.x = v.x * mt._11 + v.y * mt._21 + v.z * mt._31 + mt._41;
	v2.y = v.x * mt._12 + v.y * mt._22 + v.z * mt._32 + mt._42;
	v2.z = v.x * mt._13 + v.y * mt._23 + v.z * mt._33 + mt._43;
	return v2;
}// MtrxVec3

// ʖ@̎擾
VEC3 Get_FaceNormal(VEC3 *v)
{
	VEC3	v1,v2;
	
	v1 = Vec3Sub(v[1], v[0]);
	v2 = Vec3Sub(v[2], v[1]);
	 return Vec3Normalize(Vec3Cross(v1, v2));
}// Get_FaceNormal

// ʁE_@xNgZo
void Set_Normal()
{
	int		i,j,k;
	VEC3	n_v,v[4];
	
	// ʖ@xNgZo
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			v[j] = gmCube.v[gmCube.f[i][j]];
		}
		gmCube.fn[i] = Get_FaceNormal(v);
	}
	// _@xNgZo
	for(i=0; i<8; i++){
		n_v.x = 0.0f;
		n_v.y = 0.0f;
		n_v.z = 0.0f;
		for(j=0; j<6; j++){
			for(k=0; k<4; k++){
				if(i == gmCube.f[j][k]){
					n_v.x += gmCube.fn[j].x;
					n_v.y += gmCube.fn[j].y;
					n_v.z += gmCube.fn[j].z;
					break;
				}
			}
		}
		gmCube.n[i] = Vec3Normalize(n_v);
	}
}// Set_Normal

// ZEXeVobt@
void Clear_Z_StencilBuf()
{
	int	i,j;
	
	for(i=0; i<HEIGHT; i++){
		for(j=0; j<WIDTH; j++){
			gZBuf[i][j] = gZFar;
			gStencilBuf[i][j] = false;
		}
	}
}// Clear_Z_StencilBuf

// ̕`
void Draw_Cube(HDC hDC, VEC3 v_sun)
{
	int			i,j;
	VEC3		v_wv[4],v_all[4];
	VEC3		v_look;								// _王_ւ̃xNg
	const int	d_perspect = HEIGHT;				// ۂł̓eXN[Ǝ_̋
	const POINT	offset = {WIDTH / 2, HEIGHT / 2};	// ی̓񎟌W̕sړ
	const float	power1 = 0.7f;						// ˂̋i0 ` 1j
	const int	specular_power = 3;					// XyL˂̋
	const RGBB	material = {255, 255, 255};			// ʂ̃fBt[YFieF 0 ` 255j
	const RGBB	ambient = {10, 10, 10};				// ieF 0 ` 255j
	float		power2;
	UINT		r,g,b;
	POLYPAINT	ply1[4];							// 4_|SFh
	POLYPAINT	ply2[2][3];							// 3_|SFh
	
	gMtWorldView	= MtrxMult(gMtWorld, gMtView);
	gMtAll			= MtrxMult(gMtWorldView, gMtProj);
	
	// xNg
	VEC3	posLookAt = MtrxVec3(gPosLookAt, gMtWorld);
	v_look	= Vec3Normalize(MtrxVec3(Vec3Sub(posLookAt, gPosLook), gMtView));
	
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			int  index = gmCube.f[i][j];
			// _̃[hEr[sϊ
			v_wv[j] = Vec3Normalize(MtrxVec3(gmCube.v[index], gMtWorldView));
		}
		// ʖ@xNgvZiJOpj
		VEC3	fn_cull = Get_FaceNormal(v_wv);
		// JO
		float	dot_cull = Vec3Dot(v_look, fn_cull);
		if(dot_cull < 0){	// Жʕ\
			for(j=0; j<4; j++){
				int  index = gmCube.f[i][j];
				// _̃[hEr[EvWFNVsϊ
				v_all[j] = MtrxVec3(gmCube.v[index], gMtAll);
				// _@xNg̃[hsϊ
				VEC3	n_color;
				n_color = MtrxVec3(gmCube.n[index], gMtWorld);
				n_color = Vec3Normalize(n_color);
				// Ȉ Phong ƖfɂXyLːFݒ
				power2 = power1 * (float) pow(Vec3Dot(v_sun, n_color), (int) specular_power);
				if(power2 < 0){
					power2 = 0;
				}
				r = (UINT)(material.r * power2 + ambient.r);
				g = (UINT)(material.g * power2 + ambient.g);
				b = (UINT)(material.b * power2 + ambient.b);
				if(r > 255)	r = 255;
				if(g > 255)	g = 255;
				if(b > 255)	b = 255;
				float size_rate = d_perspect;
				if(gFlagPerspect)
					size_rate /= (v_all[j].z + gPosLookAt.z - gPosLook.z);
				ply1[j].pos.x	= (long)( v_all[j].x * size_rate + offset.x);
				ply1[j].pos.y	= (long)(-v_all[j].y * size_rate + offset.y);
				ply1[j].z		= v_all[j].z;
				ply1[j].c.a	= 0;
				ply1[j].c.r	= r;
				ply1[j].c.g	= g;
				ply1[j].c.b	= b;
			}
			ply2[0][0] = ply1[0];
			ply2[0][1] = ply1[1];
			ply2[0][2] = ply1[2];
			ply2[1][0] = ply1[0];
			ply2[1][1] = ply1[2];
			ply2[1][2] = ply1[3];
			Paint_Triangle(hDC, ply2[0]);
			Paint_Triangle(hDC, ply2[1]);
		}
	}
}// Draw_Cube

// Op`h
// pply		F Op`̒_ƐF̃Xg
void Paint_Triangle(HDC hDC, LPPOLYPAINT pply)
{
	EDGE		data[3];	// _Xg
	EDGE		aet[2];		// ANeBuӃe[uiAETj
	ET			et[HEIGHT];	// Ӄe[uiETj
	int			i,j,y_min,y_max,prev,next,next2,data_ct,aet_ct,y_next;
	float		z = 0;		// Z l
	ARGBN		argbLight;
	RATE		rate;
	
	// YW̃NbsO
	for(i=0; i<3; i++){
		if(pply[i].pos.y < 0)
			pply[i].pos.y = 0;
		if(pply[i].pos.y >= HEIGHT)
			pply[i].pos.y = HEIGHT - 1;
	}
	// YW̍őlƍŏl߂
	y_min = pply[0].pos.y;
	y_max = pply[0].pos.y;
	for(i=1; i<3; i++){
		if(pply[i].pos.y < y_min){
			y_min = pply[i].pos.y;
		}
		else if(pply[i].pos.y > y_max)
			y_max = pply[i].pos.y;
	}
	// _Xg
	for(i=0; i<3; i++){
		data[i].next = -1;
	}
	// ET 
	for(i=y_min; i<=y_max; i++){
		et[i].index = -1;
		et[i].last = -1;
	}
	data_ct = 0;	// data ̗vf
	for(i=0; i<3; i++){
		prev = i - 1;
		if(prev < 0){
			prev = 2;
		}
		next = i + 1;
		if(next >= 3){
			next = 0;
		}
		if(pply[i].pos.y < pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data1(i, prev, data_ct, data, pply, et);
			Set_Data1(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y > pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data2(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y > pply[next].pos.y && pply[i].pos.y < pply[prev].pos.y){
			Set_Data2(i, prev, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data1(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[next].pos.y && pply[i].pos.y < pply[prev].pos.y){
			Set_Data1(i, prev, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[next].pos.y && pply[i].pos.y == pply[prev].pos.y){
			Set_Data1(i, i, data_ct, data, pply, et);
		}
	}
	// XLECEASYɂhׂ
	aet_ct = 0;	// AET ̗vf
	for(i=y_min; i<=y_max; i++){
		// XLC̒_
		if(et[i].index != -1){
			aet[aet_ct ++] = data[et[i].index];
			next2 = data[et[i].index].next;
			if(next2 != -1){
				aet[aet_ct ++] = data[next2];
				next2 = data[next2].next;
			}
		}
		// AET  x ɂďɃ\[g
		if(aet[0].x > aet[1].x){
			EDGE e = aet[0];
			aet[0] = aet[1];
			aet[1] = e;
		}
		// XW̃NbsO
		if(aet[0].x < 0){
			aet[0].x = 0;
		}
		if(aet[1].x >= WIDTH){
			aet[1].x = WIDTH - 1;
		}
		// XLC̕`
		for(j=aet[0].x;j<aet[1].x;j++){
			Set_ValRate(&rate, j, aet[0].x, aet[1].x);
			Set_Z(&z, &rate, aet[0].z, aet[1].z);
			if(z < gZBuf[i][j] && (!gFlagStencilJudge ||
				gFlagStencilJudge && !gStencilBuf[i][j]))   // sNZƂ Z obt@EXeV obt@
			{
				gZBuf[i][j] = z;
				if(gFlagStencilWrite){
					gStencilBuf[i][j] = true;
				}
				// ƖF
				Set_Color(&argbLight, &rate, aet[0].color, aet[1].color);
				BYTE r = (BYTE) argbLight.r;
				BYTE g = (BYTE) argbLight.g;
				BYTE b = (BYTE) argbLight.b;
				// sNZlݒ
				SetPixel(hDC, j ,i, RGB(r,g,b));
			}
		}
		// i == y_max ̗vf AET 폜
		if(i == aet[1].y_max){
			aet_ct --;
		}
		if(i == aet[0].y_max){
			aet[0] = aet[1];
			aet_ct --;
		}
		// AET ̊e x ̃XLCł̒lɍXV
		for(j=0;j<2;j++){
			y_next = i + 1;
			aet[j].x = Round(aet[j].x_min + aet[j].slant_sum);
			aet[j].slant_sum += aet[j].slant;
			Set_ValRate(&rate, y_next, aet[j].y_min, aet[j].y_max);
			Set_Color(&aet[j].color, &rate, aet[j].c_min, aet[j].c_max);
			Set_Z(&aet[j].z, &rate, aet[j].z_min, aet[j].z_max);
		}
	}
}// Paint_Triangle

// _Xgݒ1
void Set_Data1(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et)
{
	int et_idx = pply[idx_min].pos.y;
	if(et[et_idx].last == -1)
		et[et_idx].index = data_ct;
	else
		data[et[et_idx].last].next = data_ct;
	et[et_idx].last = data_ct;
	
	data[data_ct].y_min = pply[idx_min].pos.y;
	data[data_ct].y_max = pply[idx_max].pos.y;
	data[data_ct].x_min = pply[idx_min].pos.x;
	data[data_ct].x     = data[data_ct].x_min;
	data[data_ct].slant = (double)(pply[idx_max].pos.x - pply[idx_min].pos.x) / (pply[idx_max].pos.y - pply[idx_min].pos.y);
	data[data_ct].slant_sum = data[data_ct].slant;
	data[data_ct].c_min = pply[idx_min].c;
	data[data_ct].c_max = pply[idx_max].c;
	data[data_ct].color = data[data_ct].c_min;
	data[data_ct].z_min = pply[idx_min].z;
	data[data_ct].z_max = pply[idx_max].z;
	data[data_ct].z     = data[data_ct].z_min;
	data_ct ++;
}// Set_Data1

// _Xgݒ2
void Set_Data2(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et)
{
	int et_idx = pply[idx_min].pos.y + 1;
	if(et[et_idx].last == -1)
		et[et_idx].index = data_ct;
	else
		data[et[et_idx].last].next = data_ct;
	et[et_idx].last = data_ct;
	
	double	slant = (double)(pply[idx_max].pos.x - pply[idx_min].pos.x) / (pply[idx_max].pos.y - pply[idx_min].pos.y);
	RATE	rate;
	float	z;
	ARGBN	color;
	Set_ValRate(&rate, et_idx, pply[idx_min].pos.y, pply[idx_max].pos.y);
	data[data_ct].y_min = pply[idx_min].pos.y;
	data[data_ct].y_max = pply[idx_max].pos.y;
	data[data_ct].x_min = pply[idx_min].pos.x;
	data[data_ct].x     = Round(data[data_ct].x_min + slant);
	data[data_ct].slant = slant;
	data[data_ct].slant_sum = data[data_ct].slant + slant;
	Set_Color(&color, &rate, pply[idx_min].c, pply[idx_max].c);
	data[data_ct].c_min = pply[idx_min].c;
	data[data_ct].c_max = pply[idx_max].c;
	data[data_ct].color = color;
	Set_Z(&z, &rate, pply[idx_min].z, pply[idx_max].z);
	data[data_ct].z_min = pply[idx_min].z;
	data[data_ct].z_max = pply[idx_max].z;
	data[data_ct].z     = z;
	data_ct ++;
}// Set_Data2

// 䗦ݒ
void Set_ValRate(LPRATE rate, int idx, int idx_min, int idx_max)
{
	if(idx_min != idx_max){
		rate->f1 = (float)(idx - idx_min) / (idx_max - idx_min);
		rate->f2 = 1 - rate->f1;
	}
	else{
		rate->f1 = -1;
	}
}// Set_ValRate

// Fݒ
void Set_Color(LPARGBN color, LPRATE rate, ARGBN c_min, ARGBN c_max)
{
	if(rate->f1 != -1){
		color->a = (BYTE)(c_max.a * rate->f1 + c_min.a * rate->f2);
		color->r = (BYTE)(c_max.r * rate->f1 + c_min.r * rate->f2);
		color->g = (BYTE)(c_max.g * rate->f1 + c_min.g * rate->f2);
		color->b = (BYTE)(c_max.b * rate->f1 + c_min.b * rate->f2);
	}
	else{
		*color = c_min;
	}
}// Set_Color

// Zlݒ
void Set_Z(float *z, LPRATE rate, float z_min, float z_max)
{
	if(rate->f1 != -1){
		*z = z_max * rate->f1 + z_min * rate->f2;
	}
	else{
		*z = z_min;
	}
}// Set_Z

// _ľܓĐɂ
int Round(double val)
{
	return (int)(val + 0.5f);
}// Round

// 
void M_Create()
{
	// ̍쐬
	Create_Cube();
	// ʁE_@xNgݒ
	Set_Normal();
}// M_Create

// `
void M_Paint(HDC hDC)
{
	const VEC3	pos_look = {0.0f, 2.0f, -2.0f};		// _̈ʒu
	const VEC3	pos_lookat = {0.0f, 0.0f, 0.0f};	// _̈ʒu
	const VEC3	v_lookup = {0, 1, 0};				// _̏
	VEC3		v_sun = {0.0f, -1.0f, 1.0f};		// ˌ̃xNg
	const RGBB	material = {255, 255, 255};			// ʂ̃fBt[YFieF 0 ` 255j
	const RGBB	ambient = {10, 10, 10};				// ieF 0 ` 255j
	MTRX		mtScal,mtRotY,mtTrans,mtWork;
	static int	roll_y = 0;							// ]px
	
	// sݒ
	gMtView		= MtrxView(pos_look, pos_lookat, v_lookup);
	gMtProj		= MtrxPerspect(0.0f, 10.0f, 3.14f / 4, 1.0f);
//	gMtProj		= MtrxOrtho(0.0f, 10.0f, 5.0f, 5.0f);
	// ˌxNg
	v_sun.x		= - v_sun.x;
	v_sun.y		= - v_sun.y;
	v_sun.z		= - v_sun.z;
	v_sun		= Vec3Normalize(v_sun);
	// ZEXeVobt@
	Clear_Z_StencilBuf();
	// IuWFNg`
	mtScal		= MtrxScal(1.0f, 1.0f, 1.0f);
	mtRotY		= MtrxRotY(roll_y * 3.14f / 180);
	mtTrans		= MtrxTranslate(-0.4f, 0.2f, 0.0f);
	mtWork		= MtrxMult(mtScal, mtRotY);
	gMtWorld	= MtrxMult(mtWork, mtTrans);
	gFlagStencilWrite = true;
	gFlagStencilJudge = false;
	Draw_Cube(hDC, v_sun);
	mtTrans		= MtrxTranslate(0.4f, 0.0f, 0.2f);
	gMtWorld	= MtrxMult(mtWork, mtTrans);
	gFlagStencilWrite = false;
	gFlagStencilJudge = true;
	Draw_Cube(hDC, v_sun);
	// ]px
	roll_y += 10;
	if(roll_y >= 360)
		roll_y = 0;
}// M_Paint

// I
void M_Close()
{
}// M_Close