#include <windows.h>
#include <math.h>

#pragma comment(lib,"msimg32.lib")

#define MYWNDCLASS	"Engine3D_Class"
#define MYWNDTITLE	"Engine3D"
#define WIDTH		200 	// ʂ̉̃TCY
#define HEIGHT		150 	// ʂ̏c̃TCY
#define COLOR_BIT	24		// ƗpDIB̐F[x
#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2)	// S{oCgE߂
#define COLOR_BYTE	COLOR_BIT / 8	// ƗpDIB̐F[xioCgj
#define MULT1		255		// |ZΉ\̔搔̍ől
#define MULT2		255		// |ZΉ\̏搔̍ől

typedef struct{
	BYTE	r;
	BYTE	g;
	BYTE	b;
}RGBB,*LPRGBB;

typedef struct{
	BYTE	a;
	BYTE	r;
	BYTE	g;
	BYTE	b;
}ARGBB,*LPARGBB;

typedef struct{
	int	a;
	int	r;
	int	g;
	int	b;
}ARGBN,*LPARGBN;

typedef struct{
	int		index;		// ŏ̃f[^ԍ
	int		last;		// Ō̃f[^ԍ
}ET,*LPET;

typedef struct{
	float	f1;
	float	f2;
	int		n1;
	int		n2;
}RATE,*LPRATE;

typedef struct{
	float	x;
	float	y;
}VEC2,*LPVEC2;

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	POINT		pos;	// _W
	ARGBN		c1;		// _fBt[YF
	ARGBN		c2;		// _XyLF
	float		z;		// _Zl
	VEC2		t;		// eNX`W
}POLYPAINT,*LPPOLYPAINT;

typedef struct{
	int			y_min;	// ӂ̍ŏYW
	int			y_max;	// ӂ̍őYW
	int			x_min;	// ӂ̍ŏYWXW
	int			x;		// XLCƕӂ̌_XW
	double		slant;	// ӂ̌X̋t̐
	double		slant_sum;	// slant̘a
	ARGBN		c1_min;	// ӂ̍ŏYW̃fBt[YF
	ARGBN		c1_max;	// ӂ̍őYW̃fBt[YF
	ARGBN		color1;	// fBt[YF
	ARGBN		c2_min;	// ӂ̍ŏYW̃XyLF
	ARGBN		c2_max;	// ӂ̍őYW̃XyLF
	ARGBN		color2;	// XyLF
	float		z_min;	// ӂ̍ŏYWZl
	float		z_max;	// ӂ̍őYWZl
	float		z;		// Zl
	VEC2		t_min;	// ӂ̍ŏYW̃eNX`W
	VEC2		t_max;	// ӂ̍őYW̃eNX`W
	VEC2		texcrd;	// eNX`W
	int			next;	// ̃f[^ԍ
}EDGE,*LPEDGE;

typedef struct{
	union{
		struct{
			float	_11, _12, _13, _14;
			float	_21, _22, _23, _24;
			float	_31, _32, _33, _34;
			float	_41, _42, _43, _44;
		};
		float m[4][4];
	};
}MTRX,*LPMTRX;

typedef struct{
	VEC3	v[8];		// _W
	VEC3	n[8];		// _@xNg
	VEC2	t[8];		// eNX`W
	int		f[6][4];	// eʂ̒_ԍ
	VEC3	fn[6];		// ʖ@xNg
}MODEL,*LPMODEL;

typedef struct{
	HBITMAP	hBmp;
	UINT	width,height,stride;
	LPDWORD	pBits;
}TEX,*LPTEX;

TEX			gTex;						// eNX`
const RGBB	gAmbient = {10, 10, 10};	// ieF 0 ` 255j
const int	gSpecularPower = 3;			// XyL˂̋

HBITMAP	ghBmpWork = NULL;
BYTE	*gpBitsWork = NULL;
MODEL	gmCube;						// ̏
float	gZBuf[HEIGHT][WIDTH];		// Zobt@
float	gZFar = 1;					// ĉZl
MTRX	gMtProj,gMtView,gMtWorld,gMtWorldView,gMtAll;
VEC3	gPosLook,gPosLookAt;
bool	gFlagPerspect = false;		// false:sہAtrue:ˉe
UINT	gnStride = 0;				// ƗpDIB̂SoCgE
BYTE	gMultTbl[MULT1+1][MULT2+1];	// |Z̑Ή\i䗦j

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Create_Work_Dib();
void Create_Cube();
VEC3 Vec3Sub(VEC3 v1, VEC3 v2);
VEC3 Vec3Normalize(VEC3 vin);
float Vec3Dot(VEC3 v1, VEC3 v2);
VEC3 Vec3Cross(VEC3 v1, VEC3 v2);
MTRX MtrxIdent();
MTRX MtrxRotY(float radian);
MTRX MtrxTranslate(float x, float y, float z);
MTRX MtrxScal(float x, float y, float z);
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup);
MTRX MtrxPerspect(float zn, float zf, float fov_y, float aspect);
MTRX MtrxOrtho(float zn, float zf, float w, float h);
MTRX MtrxMult(MTRX mt1, MTRX mt2);
VEC3 MtrxVec3(VEC3 v, MTRX mt);
VEC3 Get_FaceNormal(VEC3 *v);
void Set_Normal();
void Clear_ZBuf();
void Draw_Cube(HDC hDC, VEC3 v_sun);
void Paint_Triangle(HDC hDC, LPPOLYPAINT pp);
void Set_Data1(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et);
void Set_Data2(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et);
void Set_TexCrd(VEC2 *texcrd, LPRATE rate, VEC2 t_min, VEC2 t_max);
void Set_ValRate(LPRATE rate, int idx, int idx_min, int idx_max);
void Set_Color(LPARGBN color, LPRATE rate, ARGBN c_min, ARGBN c_max);
void Set_Z(float *z, LPRATE rate, float z_min, float z_max);
int Round(double val);
void M_Create();
void M_Paint(HDC hDC);
void M_Close();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		M_Create();
		SetTimer(hWnd, 1, 100, NULL);
		return 0;
	case WM_TIMER:
		InvalidateRect(hWnd, NULL, FALSE);	// ĕ`
		break;
	case WM_PAINT:
		{
			HDC 		hDC,hDCcp;
			HBITMAP		hBmpPre;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			Create_Work_Dib();
			if(ghBmpWork){
				hDCcp = CreateCompatibleDC(hDC);
				hBmpPre = (HBITMAP) SelectObject(hDCcp, ghBmpWork);
				HRGN hrgn = CreateRectRgn(0, 0, WIDTH, HEIGHT);
				SelectClipRgn(hDCcp, hrgn);
				DeleteObject(hrgn);
				M_Paint(hDCcp);
				BitBlt(hDC, 0, 0, WIDTH, HEIGHT, hDCcp, 0, 0, SRCCOPY);
				SelectObject(hDCcp, hBmpPre);
				SelectClipRgn(hDCcp, (HRGN) NULL);
				DeleteDC(hDCcp);
				DeleteObject(ghBmpWork);
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		KillTimer(hWnd, 1);
		M_Close();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// ƗpDIB̍쐬
void Create_Work_Dib()
{
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= WIDTH;
	bmi.bmiHeader.biHeight			= -HEIGHT;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= COLOR_BIT;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	ghBmpWork = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (VOID **)&gpBitsWork, NULL, 0);
	gnStride = WIDTHBYTES(WIDTH * COLOR_BIT);
	int workSize = gnStride * HEIGHT;
	ZeroMemory(gpBitsWork, workSize);
}// Create_Work_Dib

// ̂̍쐬
void Create_Cube()
{
	VEC3	v[8]	=	{{0.5f,0.5f,-0.5f},{0.5f,0.5f,0.5f},{-0.5f,0.5f,0.5f},
						{-0.5f,0.5f,-0.5f},{0.5f,-0.5f,-0.5f},{0.5f,-0.5f,0.5f},
						{-0.5f,-0.5f,0.5f},{-0.5f,-0.5f,-0.5f}};
	VEC2	t[8]	=	{{0,0},{0,0},{1,0},{1,0},{0,1},{0,1},{1,1},{1,1}};
	int		f[6][4]	=	{{3,2,1,0},{0,1,5,4},{1,2,6,5},{2,3,7,6},{3,0,4,7},{4,5,6,7}};
	memcpy(gmCube.v, v, sizeof(gmCube.v));
	memcpy(gmCube.t, t, sizeof(gmCube.t));
	memcpy(gmCube.f, f, sizeof(gmCube.f));
}// Create_Cube

// xNg̈Z
VEC3 Vec3Sub(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.x  - v2.x;
	vout.y = v1.y  - v2.y;
	vout.z = v1.z  - v2.z;
	return vout;
}// Vec3Sub

// PʃxNg
VEC3 Vec3Normalize(VEC3 vin)
{
	VEC3	vout;
	float	len = (float) sqrt(vin.x * vin.x + vin.y * vin.y + vin.z * vin.z);
	if(len == 0.0f){
		vout.x = 0.0f;
		vout.y = 0.0f;
		vout.z = 0.0f;
	}
	else{
		vout.x = vin.x / len;
		vout.y = vin.y / len;
		vout.z = vin.z / len;
	}
	return vout;
}// Vec3Normalize

// 
float Vec3Dot(VEC3 v1, VEC3 v2)
{
	return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z);
}

// O
VEC3 Vec3Cross(VEC3 v1, VEC3 v2)
{
	VEC3	vout;
	vout.x = v1.y * v2.z - v1.z * v2.y;
	vout.y = v1.z * v2.x - v1.x * v2.z;
	vout.z = v1.x * v2.y - v1.y * v2.x;
	return vout;
}// Vec3Cross

// Pʍs
MTRX MtrxIdent()
{
	MTRX mt = { 1,0,0,0,
				0,1,0,0,
				0,0,1,0,
				0,0,0,1};
	return mt;
}// MtrxIdent

// sY]
MTRX MtrxRotY(float radian)
{
	MTRX mt = MtrxIdent();
	mt._11 = (float)  cos(radian);
	mt._13 = (float) -sin(radian);
	mt._31 = (float)  sin(radian);
	mt._33 = (float)  cos(radian);
	return mt;
}// MtrxRotY

// s̈ړ
MTRX MtrxTranslate(float x, float y, float z)
{
	MTRX mt = MtrxIdent();
	mt._41 = x;
	mt._42 = y;
	mt._43 = z;
	return mt;
}// MtrxTranslate

// s̃XP[O
MTRX MtrxScal(float x, float y, float z)
{
	MTRX mt = MtrxIdent();
	mt._11 = x;
	mt._22 = y;
	mt._33 = z;
	return mt;
}// MtrxScal

// r[s
MTRX MtrxView(VEC3 v_look, VEC3 v_lookat, VEC3 v_lookup)
{
	MTRX mt;
	VEC3 v_x,v_y,v_z;
	gPosLook	= v_look;
	gPosLookAt	= v_lookat;
	v_z = Vec3Normalize(Vec3Sub(v_lookat, v_look));
	v_x = Vec3Normalize(Vec3Cross(v_lookup, v_z));
	v_y = Vec3Cross(v_z, v_x);
	mt._11 = v_x.x;
	mt._12 = v_y.x;
	mt._13 = v_z.x;
	mt._14 = 0;
	mt._21 = v_x.y;
	mt._22 = v_y.y;
	mt._23 = v_z.y;
	mt._24 = 0;
	mt._31 = v_x.z;
	mt._32 = v_y.z;
	mt._33 = v_z.z;
	mt._34 = 0;
	mt._41 = - Vec3Dot(v_x, v_look);
	mt._42 = - Vec3Dot(v_y, v_look);
	mt._43 = - Vec3Dot(v_z, v_look);
	mt._44 = 1;
	return mt;
}// MtrxView
/*
// ˉeۍs
MTRX MtrxPerspect(float near_plane, float far_plane, float fov_horiz, float fov_vert)
{
	float	h, w, Q;
	
	gZFar = far_plane;
	
	if(fov_horiz == 0)
		fov_horiz = 1;
	if(fov_vert == 0)
		fov_vert = 1;

	w = 1.0f / (float)tan(fov_horiz * 0.5);  // 1/tan(x) == cot(x)
	h = 1.0f / (float)tan(fov_vert * 0.5);   // 1/tan(x) == cot(x)
	Q = far_plane / (far_plane - near_plane);
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = w;
	mt._22 = h;
	mt._33 = Q;
	mt._43 = -Q * near_plane;
	mt._34 = 1;
	
	return mt;
}// MtrxPerspect
*/

// ˉeۍs
MTRX MtrxPerspect(float zn, float zf, float fov_y, float aspect)
{
	float	c, s, Q;
	
	gFlagPerspect = true;
	
	if(zf == 0){
		zf = 0.001f;
	}
	gZFar = zf;
	
	c = (float) cos(fov_y * 0.5);
	s = (float) sin(aspect * 0.5);
	if(zn != zf){
		Q = s / (1.0f - zn / zf);
	}
	else{
		Q = 1.0f;
	}
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = c;
	mt._22 = c;
	mt._33 = Q;
	mt._43 = -Q * zn;
	mt._34 = s;
	
	return mt;
}// MtrxPerspect

// sۍs
MTRX MtrxOrtho(float zn, float zf, float w, float h)
{
	float	sub;
	
	gFlagPerspect = false;
	
	gZFar = zf;
	
	if(zn != zf)
		sub = zf - zn;
	else
		sub = 1;
	if(w == 0)
		w = 1;
	if(h == 0)
		h = 1;
	
	MTRX mt;
	ZeroMemory(&mt, sizeof(mt));

	mt._11 = 2.0f / w;
	mt._22 = 2.0f / h;
	mt._33 = 1.0f / sub;
	mt._43 = - zn / sub;
	mt._34 = 1;
	
	return mt;
}// MtrxOrtho

// sA
MTRX MtrxMult(MTRX mt1, MTRX mt2)
{
	MTRX mt;
	mt._11 = mt1._11 * mt2._11 + mt1._12 * mt2._21 + mt1._13 * mt2._31 + mt1._14 * mt2._41;
	mt._12 = mt1._11 * mt2._12 + mt1._12 * mt2._22 + mt1._13 * mt2._32 + mt1._14 * mt2._42;
	mt._13 = mt1._11 * mt2._13 + mt1._12 * mt2._23 + mt1._13 * mt2._33 + mt1._14 * mt2._43;
	mt._14 = mt1._11 * mt2._14 + mt1._12 * mt2._24 + mt1._13 * mt2._34 + mt1._14 * mt2._44;
	mt._21 = mt1._21 * mt2._11 + mt1._22 * mt2._21 + mt1._23 * mt2._31 + mt1._24 * mt2._41;
	mt._22 = mt1._21 * mt2._12 + mt1._22 * mt2._22 + mt1._23 * mt2._32 + mt1._24 * mt2._42;
	mt._23 = mt1._21 * mt2._13 + mt1._22 * mt2._23 + mt1._23 * mt2._33 + mt1._24 * mt2._43;
	mt._24 = mt1._21 * mt2._14 + mt1._22 * mt2._24 + mt1._23 * mt2._34 + mt1._24 * mt2._44;
	mt._31 = mt1._31 * mt2._11 + mt1._32 * mt2._21 + mt1._33 * mt2._31 + mt1._34 * mt2._41;
	mt._32 = mt1._31 * mt2._12 + mt1._32 * mt2._22 + mt1._33 * mt2._32 + mt1._34 * mt2._42;
	mt._33 = mt1._31 * mt2._13 + mt1._32 * mt2._23 + mt1._33 * mt2._33 + mt1._34 * mt2._43;
	mt._34 = mt1._31 * mt2._14 + mt1._32 * mt2._24 + mt1._33 * mt2._34 + mt1._34 * mt2._44;
	mt._41 = mt1._41 * mt2._11 + mt1._42 * mt2._21 + mt1._43 * mt2._31 + mt1._44 * mt2._41;
	mt._42 = mt1._41 * mt2._12 + mt1._42 * mt2._22 + mt1._43 * mt2._32 + mt1._44 * mt2._42;
	mt._43 = mt1._41 * mt2._13 + mt1._42 * mt2._23 + mt1._43 * mt2._33 + mt1._44 * mt2._43;
	mt._44 = mt1._41 * mt2._14 + mt1._42 * mt2._24 + mt1._43 * mt2._34 + mt1._44 * mt2._44;
	return mt;
}// MtrxMult

// sWɓKp
VEC3 MtrxVec3(VEC3 v, MTRX mt)
{
	VEC3 v2;
	v2.x = v.x * mt._11 + v.y * mt._21 + v.z * mt._31 + mt._41;
	v2.y = v.x * mt._12 + v.y * mt._22 + v.z * mt._32 + mt._42;
	v2.z = v.x * mt._13 + v.y * mt._23 + v.z * mt._33 + mt._43;
	return v2;
}// MtrxVec3

// ʖ@̎擾
VEC3 Get_FaceNormal(VEC3 *v)
{
	VEC3	v1,v2;
	
	v1 = Vec3Sub(v[1], v[0]);
	v2 = Vec3Sub(v[2], v[1]);
	 return Vec3Normalize(Vec3Cross(v1, v2));
}// Get_FaceNormal

// ʁE_@xNgZo
void Set_Normal()
{
	int		i,j,k;
	VEC3	n_v,v[4];
	
	// ʖ@xNgZo
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			v[j] = gmCube.v[gmCube.f[i][j]];
		}
		gmCube.fn[i] = Get_FaceNormal(v);
	}
	// _@xNgZo
	for(i=0; i<8; i++){
		n_v.x = 0.0f;
		n_v.y = 0.0f;
		n_v.z = 0.0f;
		for(j=0; j<6; j++){
			for(k=0; k<4; k++){
				if(i == gmCube.f[j][k]){
					n_v.x += gmCube.fn[j].x;
					n_v.y += gmCube.fn[j].y;
					n_v.z += gmCube.fn[j].z;
					break;
				}
			}
		}
		gmCube.n[i] = Vec3Normalize(n_v);
	}
}// Set_Normal

// Zobt@
void Clear_ZBuf()
{
	int	i,j;
	
	for(i=0; i<HEIGHT; i++){
		for(j=0; j<WIDTH; j++){
			gZBuf[i][j] = gZFar;
		}
	}
}// Clear_ZBuf

// ̕`
void Draw_Cube(HDC hDC, VEC3 v_sun)
{
	int			i,j;
	VEC3		v_wv[4],v_all[4];
	VEC3		v_look;								// _王_ւ̃xNg
	const int	d_perspect = HEIGHT;				// ۂł̓eXN[Ǝ_̋
	const POINT	offset = {WIDTH / 2, HEIGHT / 2};	// ی̓񎟌W̕sړ
	const float	power1 = 0.7f;						// ˂̋i0 ` 1j
	const ARGBB	diffuse = {127, 255, 255, 255};		// ʂ̃fBt[YFieF 0 ` 255j
	const RGBB	specular = {255, 255, 255};			// ʂ̃XyLFieF 0 ` 255j
	float		power2,powerDiffuse,powerSpecular;
	ARGBN		argbDiffuse,argbSpecular;
	POLYPAINT	ply1[4];							// 4_|SFh
	POLYPAINT	ply2[2][3];							// 3_|SFh
	
	gMtWorldView	= MtrxMult(gMtWorld, gMtView);
	gMtAll			= MtrxMult(gMtWorldView, gMtProj);
	
	// xNg
	VEC3	posLookAt = MtrxVec3(gPosLookAt, gMtWorld);
	v_look	= Vec3Normalize(MtrxVec3(Vec3Sub(posLookAt, gPosLook), gMtView));
	
	for(i=0; i<6; i++){
		for(j=0; j<4; j++){
			int  index = gmCube.f[i][j];
			// _̃[hEr[sϊ
			v_wv[j] = Vec3Normalize(MtrxVec3(gmCube.v[index], gMtWorldView));
		}
		// ʖ@xNgvZiJOpj
		VEC3	fn_cull = Get_FaceNormal(v_wv);
		// JO
		float	dot_cull = Vec3Dot(v_look, fn_cull);
		if(dot_cull < 0){	// Жʕ\
			for(j=0; j<4; j++){
				int  index = gmCube.f[i][j];
				// _̃[hEr[EvWFNVsϊ
				v_all[j] = MtrxVec3(gmCube.v[index], gMtAll);
				// _@xNg̃[hsϊ
				VEC3	n_color;
				n_color = MtrxVec3(gmCube.n[index], gMtWorld);
				n_color = Vec3Normalize(n_color);
				// Lambert ƖfɂgUːFݒ
				power2 = Vec3Dot(v_sun, n_color);
				powerDiffuse = power1 * power2;
				if(powerDiffuse < 0){
					powerDiffuse = 0;
				}
				argbDiffuse.a = diffuse.a;
				argbDiffuse.r = (UINT)(diffuse.r * powerDiffuse);
				argbDiffuse.g = (UINT)(diffuse.g * powerDiffuse);
				argbDiffuse.b = (UINT)(diffuse.b * powerDiffuse);
				if(argbDiffuse.r > 255)	argbDiffuse.r = 255;
				if(argbDiffuse.g > 255)	argbDiffuse.g = 255;
				if(argbDiffuse.b > 255)	argbDiffuse.b = 255;
				// Ȉ Phong ƖfɂXyLːFݒ
				powerSpecular = power1 * (float) pow(power2, (int) gSpecularPower);
				if(powerSpecular < 0){
					powerSpecular = 0;
				}
				argbSpecular.a = diffuse.a;
				argbSpecular.r = (UINT)(specular.r * powerSpecular);
				argbSpecular.g = (UINT)(specular.g * powerSpecular);
				argbSpecular.b = (UINT)(specular.b * powerSpecular);
				if(argbSpecular.r > 255)	argbSpecular.r = 255;
				if(argbSpecular.g > 255)	argbSpecular.g = 255;
				if(argbSpecular.b > 255)	argbSpecular.b = 255;
				float size_rate = d_perspect;
				if(gFlagPerspect)
					size_rate /= (v_all[j].z + gPosLookAt.z - gPosLook.z);
				ply1[j].pos.x	= (long)( v_all[j].x * size_rate + offset.x);
				ply1[j].pos.y	= (long)(-v_all[j].y * size_rate + offset.y);
				ply1[j].z		= v_all[j].z;
				ply1[j].c1.a	= argbDiffuse.a;
				ply1[j].c1.r	= argbDiffuse.r;
				ply1[j].c1.g	= argbDiffuse.g;
				ply1[j].c1.b	= argbDiffuse.b;
				ply1[j].c2.a	= argbSpecular.a;
				ply1[j].c2.r	= argbSpecular.r;
				ply1[j].c2.g	= argbSpecular.g;
				ply1[j].c2.b	= argbSpecular.b;
				ply1[j].t		= gmCube.t[index];
			}
			ply2[0][0] = ply1[0];
			ply2[0][1] = ply1[1];
			ply2[0][2] = ply1[2];
			ply2[1][0] = ply1[0];
			ply2[1][1] = ply1[2];
			ply2[1][2] = ply1[3];
			Paint_Triangle(hDC, ply2[0]);
			Paint_Triangle(hDC, ply2[1]);
		}
	}
}// Draw_Cube

// Op`h
// pply		F Op`̒_ƐF̃Xg
void Paint_Triangle(HDC hDC, LPPOLYPAINT pply)
{
	EDGE		data[3];	// _Xg
	EDGE		aet[2];		// ANeBuӃe[uiAETj
	ET			et[HEIGHT];	// Ӄe[uiETj
	int			i,j,y_min,y_max,prev,next,next2,data_ct,aet_ct,y_next;
	UINT		stride_sum;
	float		z = 0;		// Z l
	ARGBN		argbDiffuse,argbSpecular,argbTex,argbVtx,argbBase;
	VEC2		texcrd;
	RATE		rate;
	
	// YW̃NbsO
	for(i=0; i<3; i++){
		if(pply[i].pos.y < 0)
			pply[i].pos.y = 0;
		if(pply[i].pos.y >= HEIGHT)
			pply[i].pos.y = HEIGHT - 1;
	}
	// YW̍őlƍŏl߂
	y_min = pply[0].pos.y;
	y_max = pply[0].pos.y;
	for(i=1; i<3; i++){
		if(pply[i].pos.y < y_min){
			y_min = pply[i].pos.y;
		}
		else if(pply[i].pos.y > y_max)
			y_max = pply[i].pos.y;
	}
	// _Xg
	for(i=0; i<3; i++){
		data[i].next = -1;
	}
	// ET 
	for(i=y_min; i<=y_max; i++){
		et[i].index = -1;
		et[i].last = -1;
	}
	data_ct = 0;	// data ̗vf
	for(i=0; i<3; i++){
		prev = i - 1;
		if(prev < 0){
			prev = 2;
		}
		next = i + 1;
		if(next >= 3){
			next = 0;
		}
		if(pply[i].pos.y < pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data1(i, prev, data_ct, data, pply, et);
			Set_Data1(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y > pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data2(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y > pply[next].pos.y && pply[i].pos.y < pply[prev].pos.y){
			Set_Data2(i, prev, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[prev].pos.y && pply[i].pos.y < pply[next].pos.y){
			Set_Data1(i, next, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[next].pos.y && pply[i].pos.y < pply[prev].pos.y){
			Set_Data1(i, prev, data_ct, data, pply, et);
		}
		else if(pply[i].pos.y == pply[next].pos.y && pply[i].pos.y == pply[prev].pos.y){
			Set_Data1(i, i, data_ct, data, pply, et);
		}
	}
	// XLECEASYɂhׂ
	aet_ct = 0;	// AET ̗vf
	stride_sum = y_min * gnStride;
	for(i=y_min; i<=y_max; i++){
		// XLC̒_
		if(et[i].index != -1){
			aet[aet_ct ++] = data[et[i].index];
			next2 = data[et[i].index].next;
			if(next2 != -1){
				aet[aet_ct ++] = data[next2];
				next2 = data[next2].next;
			}
		}
		// AET  x ɂďɃ\[g
		if(aet[0].x > aet[1].x){
			EDGE e = aet[0];
			aet[0] = aet[1];
			aet[1] = e;
		}
		// XW̃NbsO
		if(aet[0].x < 0){
			aet[0].x = 0;
		}
		if(aet[1].x >= WIDTH){
			aet[1].x = WIDTH - 1;
		}
		// XLC̕`
		LPBYTE  pb = gpBitsWork + stride_sum + aet[0].x * COLOR_BYTE;
		for(j=aet[0].x;j<aet[1].x;j++){
			Set_ValRate(&rate, j, aet[0].x, aet[1].x);
			Set_Z(&z, &rate, aet[0].z, aet[1].z);
			if(z < gZBuf[i][j]){	// sNZƂ Z obt@
				gZBuf[i][j] = z;
				// fBt[YF
				Set_Color(&argbDiffuse, &rate, aet[0].color1, aet[1].color1);
				// XyLF
				Set_Color(&argbSpecular, &rate, aet[0].color2, aet[1].color2);
				if(gSpecularPower > 0){
					argbVtx = argbSpecular;
				}
				else{
					argbVtx.a = argbVtx.r = argbVtx.g = argbVtx.b = 0;
				}
				// eNX`W
				Set_TexCrd(&texcrd, &rate, aet[0].texcrd, aet[1].texcrd);
				if(texcrd.x < 0)
					texcrd.x -= (int)(texcrd.x - 1);
				else if(texcrd.x > 1)
					texcrd.x -= (int) texcrd.x;
				if(texcrd.y < 0)
					texcrd.y -= (int)(texcrd.y - 1);
				else if(texcrd.y > 1)
					texcrd.y -= (int) texcrd.y;
				// eNX`F
				int		xTex = (int)(texcrd.x * (gTex.width - 1));
				int		yTex = (int)(texcrd.y * (gTex.height - 1));
				DWORD	val = gTex.pBits[gTex.width * yTex + xTex];
				argbTex.a = (BYTE)(val >> 24);
				argbTex.r = (BYTE)(val >> 16);
				argbTex.g = (BYTE)(val >> 8);
				argbTex.b = (BYTE)(val);
				// eNX`ɔZWݒ
				argbTex.r = gMultTbl[argbTex.r][argbDiffuse.r];
				argbTex.g = gMultTbl[argbTex.g][argbDiffuse.g];
				argbTex.b = gMultTbl[argbTex.b][argbDiffuse.b];
				// eNX`ɃnCCgݒ
				argbVtx.r += argbTex.r;
				argbVtx.g += argbTex.g;
				argbVtx.b += argbTex.b;
				// ݒ
				argbVtx.r += gAmbient.r;
				argbVtx.g += gAmbient.g;
				argbVtx.b += gAmbient.b;
				if(argbVtx.r < 0)
					argbVtx.r = 0;
				else if(argbVtx.r > 255)
					argbVtx.r = 255;
				if(argbVtx.g < 0)
					argbVtx.g = 0;
				else if(argbVtx.g > 255)
					argbVtx.g = 255;
				if(argbVtx.b < 0)
					argbVtx.b = 0;
				else if(argbVtx.b > 255)
					argbVtx.b = 255;
				// At@ ufBO
				argbVtx.a = gMultTbl[argbVtx.a][argbTex.a];
				argbBase.a = MULT2 - argbVtx.a;
				argbBase.b = *(pb + 0);
				argbBase.g = *(pb + 1);
				argbBase.r = *(pb + 2);
				argbVtx.r = gMultTbl[argbVtx.r][argbVtx.a] + gMultTbl[argbBase.r][argbBase.a];
				argbVtx.g = gMultTbl[argbVtx.g][argbVtx.a] + gMultTbl[argbBase.g][argbBase.a];
				argbVtx.b = gMultTbl[argbVtx.b][argbVtx.a] + gMultTbl[argbBase.b][argbBase.a];
				// sNZlݒ
				*pb ++ = (BYTE) argbVtx.b;
				*pb ++ = (BYTE) argbVtx.g;
				*pb ++ = (BYTE) argbVtx.r;
			}
			else{
				pb += COLOR_BYTE;
			}
		}
		stride_sum += gnStride;
		// i == y_max ̗vf AET 폜
		if(i == aet[1].y_max){
			aet_ct --;
		}
		if(i == aet[0].y_max){
			aet[0] = aet[1];
			aet_ct --;
		}
		// AET ̊e x ̃XLCł̒lɍXV
		for(j=0;j<2;j++){
			y_next = i + 1;
			aet[j].x = Round(aet[j].x_min + aet[j].slant_sum);
			aet[j].slant_sum += aet[j].slant;
			Set_ValRate(&rate, y_next, aet[j].y_min, aet[j].y_max);
			Set_Color(&aet[j].color1, &rate, aet[j].c1_min, aet[j].c1_max);
			Set_Color(&aet[j].color2, &rate, aet[j].c2_min, aet[j].c2_max);
			Set_Z(&aet[j].z, &rate, aet[j].z_min, aet[j].z_max);
			Set_TexCrd(&aet[j].texcrd, &rate, aet[j].t_min, aet[j].t_max);
		}
	}
}// Paint_Triangle

// _Xgݒ1
void Set_Data1(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et)
{
	int et_idx = pply[idx_min].pos.y;
	if(et[et_idx].last == -1)
		et[et_idx].index = data_ct;
	else
		data[et[et_idx].last].next = data_ct;
	et[et_idx].last = data_ct;
	
	data[data_ct].y_min = pply[idx_min].pos.y;
	data[data_ct].y_max = pply[idx_max].pos.y;
	data[data_ct].x_min = pply[idx_min].pos.x;
	data[data_ct].x     = data[data_ct].x_min;
	data[data_ct].slant = (double)(pply[idx_max].pos.x - pply[idx_min].pos.x) / (pply[idx_max].pos.y - pply[idx_min].pos.y);
	data[data_ct].slant_sum = data[data_ct].slant;
	data[data_ct].c1_min = pply[idx_min].c1;
	data[data_ct].c1_max = pply[idx_max].c1;
	data[data_ct].color1 = data[data_ct].c1_min;
	data[data_ct].c2_min = pply[idx_min].c2;
	data[data_ct].c2_max = pply[idx_max].c2;
	data[data_ct].color2 = data[data_ct].c2_min;
	data[data_ct].z_min  = pply[idx_min].z;
	data[data_ct].z_max  = pply[idx_max].z;
	data[data_ct].z      = data[data_ct].z_min;
	data[data_ct].t_min  = pply[idx_min].t;
	data[data_ct].t_max  = pply[idx_max].t;
	data[data_ct].texcrd = data[data_ct].t_min;
	data_ct ++;
}// Set_Data1

// _Xgݒ2
void Set_Data2(int idx_min, int idx_max, int &data_ct, LPEDGE data, LPPOLYPAINT pply, LPET et)
{
	int et_idx = pply[idx_min].pos.y + 1;
	if(et[et_idx].last == -1)
		et[et_idx].index = data_ct;
	else
		data[et[et_idx].last].next = data_ct;
	et[et_idx].last = data_ct;
	
	double	slant = (double)(pply[idx_max].pos.x - pply[idx_min].pos.x) / (pply[idx_max].pos.y - pply[idx_min].pos.y);
	RATE	rate;
	VEC2	texcrd;
	float	z;
	ARGBN	color1,color2;
	Set_ValRate(&rate, et_idx, pply[idx_min].pos.y, pply[idx_max].pos.y);
	data[data_ct].y_min = pply[idx_min].pos.y;
	data[data_ct].y_max = pply[idx_max].pos.y;
	data[data_ct].x_min = pply[idx_min].pos.x;
	data[data_ct].x     = Round(data[data_ct].x_min + slant);
	data[data_ct].slant = slant;
	data[data_ct].slant_sum = data[data_ct].slant + slant;
	Set_Color(&color1, &rate, pply[idx_min].c1, pply[idx_max].c1);
	data[data_ct].c1_min = pply[idx_min].c1;
	data[data_ct].c1_max = pply[idx_max].c1;
	data[data_ct].color1 = color1;
	Set_Color(&color2, &rate, pply[idx_min].c2, pply[idx_max].c2);
	data[data_ct].c2_min = pply[idx_min].c2;
	data[data_ct].c2_max = pply[idx_max].c2;
	data[data_ct].color2 = color2;
	Set_Z(&z, &rate, pply[idx_min].z, pply[idx_max].z);
	data[data_ct].z_min = pply[idx_min].z;
	data[data_ct].z_max = pply[idx_max].z;
	data[data_ct].z     = z;
	Set_TexCrd(&texcrd, &rate, pply[idx_min].t, pply[idx_max].t);
	data[data_ct].t_min = pply[idx_min].t;
	data[data_ct].t_max = pply[idx_max].t;
	data[data_ct].texcrd = texcrd;
	data_ct ++;
}// Set_Data2

// 䗦ݒ
void Set_ValRate(LPRATE rate, int idx, int idx_min, int idx_max)
{
	if(idx_min != idx_max){
		rate->f1 = (float)(idx - idx_min) / (idx_max - idx_min);
		rate->f2 = 1 - rate->f1;
		rate->n1 = (int)(rate->f1 * MULT2);
		rate->n2 = MULT2 - rate->n1;
	}
	else{
		rate->f1 = -1;
		rate->n1 = -1;
	}
}// Set_ValRate

// Fݒ
void Set_Color(LPARGBN color, LPRATE rate, ARGBN c_min, ARGBN c_max)
{
	if(rate->n1 != -1){
		color->a = gMultTbl[c_max.a][rate->n1] + gMultTbl[c_min.a][rate->n2];
		color->r = gMultTbl[c_max.r][rate->n1] + gMultTbl[c_min.r][rate->n2];
		color->g = gMultTbl[c_max.g][rate->n1] + gMultTbl[c_min.g][rate->n2];
		color->b = gMultTbl[c_max.b][rate->n1] + gMultTbl[c_min.b][rate->n2];
	}
	else{
		*color = c_min;
	}
}// Set_Color

// Zlݒ
void Set_Z(float *z, LPRATE rate, float z_min, float z_max)
{
	if(rate->f1 != -1){
		*z = z_max * rate->f1 + z_min * rate->f2;
	}
	else{
		*z = z_min;
	}
}// Set_Z

// eNX`Wݒ
void Set_TexCrd(VEC2 *texcrd, LPRATE rate, VEC2 t_min, VEC2 t_max)
{
	if(rate->f1 != -1){
		texcrd->x = t_max.x * rate->f1 + t_min.x * rate->f2;
		texcrd->y = t_max.y * rate->f1 + t_min.y * rate->f2;
	}
	else{
		*texcrd = t_min;
	}
}// Set_TexCrd

// _ľܓĐɂ
int Round(double val)
{
	return (int)(val + 0.5f);
}// Round

// 
void M_Create()
{
	// ̍쐬
	Create_Cube();
	// ʁE_@xNgݒ
	Set_Normal();
	// |ZΉ\쐬
	int i,j;
	for(i=0; i<=MULT1; i++){
		for(j=0; j<=MULT2; j++){
			gMultTbl[i][j] = ((i * j) / MULT2);
		}
	}
	// eNX` t@C
	BITMAP		bmp;
	BITMAPINFO	bi;
	char		*p;
	char		path[MAX_PATH];
	GetModuleFileName(NULL, path, sizeof(path));
	p = strrchr(path, '\\');
	strcpy(p+1, "tex2.bmp");
	HBITMAP hBmp = (HBITMAP) LoadImage(NULL, path, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	GetObject(hBmp, sizeof(bmp), &bmp);
	ZeroMemory(&bi, sizeof(bi));
	bi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= bmp.bmWidth;
	bi.bmiHeader.biHeight		= - bmp.bmHeight;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount		= 32;
	bi.bmiHeader.biCompression	= BI_RGB;
	gTex.hBmp = (HBITMAP) CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (VOID**) &gTex.pBits, NULL, 0);
	HDC	 hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	hbmOld1 = (HBITMAP)SelectObject(hdcCp1, gTex.hBmp);
	hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmp);
	BitBlt(hdcCp1, 0, 0, bmp.bmWidth, bmp.bmHeight, hdcCp2, 0, 0, SRCCOPY);
	SelectObject(hdcCp1, hbmOld1);
	SelectObject(hdcCp2, hbmOld2);
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmp);
	gTex.width  = bmp.bmWidth;
	gTex.height = bmp.bmHeight;
	gTex.stride = WIDTHBYTES(bi.bmiHeader.biWidth * bi.bmiHeader.biBitCount);
	// 24bpp ȉ̏ꍇ͓x 255 ݒ
	if(bmp.bmBitsPixel <= 24){
		int size;
		size = gTex.width * gTex.height;
		PBYTE   pb = (PBYTE) gTex.pBits + 3;
		for(i = 0; i < size; i++){
			*pb = MULT2;
			pb += 4;
		}
	}
}// M_Create

// `
void M_Paint(HDC hDC)
{
	const VEC3	pos_look = {0.0f, 2.0f, -2.0f};		// _̈ʒu
	const VEC3	pos_lookat = {0.0f, 0.0f, 0.0f};	// _̈ʒu
	const VEC3	v_lookup = {0, 1, 0};				// _̏
	VEC3		v_sun = {0.0f, -1.0f, 1.0f};		// ˌ̃xNg
	const RGBB	material = {255, 255, 255};			// ʂ̃fBt[YFieF 0 ` 255j
	const RGBB	ambient = {10, 10, 10};				// ieF 0 ` 255j
	MTRX		mtScal,mtRotY,mtTrans,mtWork;
	static int	roll_y = 0;							// ]px
	
	// sݒ
	gMtView		= MtrxView(pos_look, pos_lookat, v_lookup);
	gMtProj		= MtrxPerspect(0.0f, 10.0f, 3.14f / 4, 1.0f);
//	gMtProj		= MtrxOrtho(0.0f, 10.0f, 5.0f, 5.0f);
	// ˌxNg
	v_sun.x		= - v_sun.x;
	v_sun.y		= - v_sun.y;
	v_sun.z		= - v_sun.z;
	v_sun		= Vec3Normalize(v_sun);
	// Zobt@
	Clear_ZBuf();
	// IuWFNg`
	mtScal		= MtrxScal(1.0f, 1.0f, 1.0f);
	mtRotY		= MtrxRotY(roll_y * 3.14f / 180);
	mtWork		= MtrxMult(mtScal, mtRotY);
	mtTrans		= MtrxTranslate(-0.2f, 0.2f, 0.0f);
	gMtWorld	= MtrxMult(mtWork, mtTrans);
	Draw_Cube(hDC, v_sun);
	mtTrans		= MtrxTranslate(0.2f, 0.0f,-0.2f);
	gMtWorld	= MtrxMult(mtWork, mtTrans);
	Draw_Cube(hDC, v_sun);
	// ]px
	roll_y += 10;
	if(roll_y >= 360)
		roll_y = 0;
}// M_Paint

// I
void M_Close()
{
	DeleteObject(gTex.hBmp);
}// M_Close